VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsTransactedForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Compare Database
Option Explicit

Private WithEvents thisForm As Access.Form
Attribute thisForm.VB_VarHelpID = -1
Private ws As Workspace

'http://support.microsoft.com/kb/248011
Private boolFrmDirty As Boolean
Private boolFrmSaved As Boolean

Private WithEvents m_save_add As Access.CommandButton
Attribute m_save_add.VB_VarHelpID = -1
Private WithEvents m_save_edit As Access.CommandButton
Attribute m_save_edit.VB_VarHelpID = -1
Private WithEvents m_save_quit As Access.CommandButton
Attribute m_save_quit.VB_VarHelpID = -1
Private WithEvents m_nosave_quit As Access.CommandButton
Attribute m_nosave_quit.VB_VarHelpID = -1

Const eHook As String = "[Event Procedure]"

Public Sub Init(ByRef frm As Access.Form, _
                ByVal strRecordSource As String, _
                ByRef cmd_save_add As Access.CommandButton, _
                ByRef cmd_save_edit As Access.CommandButton, _
                ByRef cmd_save_quit As Access.CommandButton, _
                ByRef cmd_nosave_quit As Access.CommandButton)
    Set thisForm = frm
    Set m_save_add = cmd_save_add
    Set m_save_edit = cmd_save_edit
    Set m_save_quit = cmd_save_quit
    Set m_nosave_quit = cmd_nosave_quit
    With thisForm
        .AfterDelConfirm = eHook
        .OnDelete = eHook
        .AfterUpdate = eHook
        .OnDirty = eHook
        .OnUnload = eHook
        Set .Recordset = OpenRS(strRecordSource)
    End With
    m_save_add.OnClick = eHook
    m_save_edit.OnClick = eHook
    m_save_quit.OnClick = eHook
    m_nosave_quit.OnClick = eHook
    Set ws = DBEngine.Workspaces(0)
End Sub

Public Property Get Dirtied() As Boolean

    Dirtied = boolFrmDirty
    
End Property

Public Property Let Dirtied(boolFrmDirtyIn As Boolean)

    boolFrmDirty = boolFrmDirtyIn
    
End Property

Public Property Get Saved() As Boolean

    Saved = boolFrmSaved
    
End Property

Public Property Let Saved(boolFrmSavedIn As Boolean)

    boolFrmSaved = boolFrmSavedIn
    
End Property


Public Sub DiscardChanges()
    If Me.Dirtied Then
        ws.Rollback
        thisForm.Undo
        thisForm.Dirty = False
        Me.Dirtied = False
    End If
End Sub

Public Sub SaveChanges()
    If Me.Dirtied Then
        thisForm.Dirty = False
        Me.Dirtied = False
        ws.CommitTrans
    End If
End Sub

Private Sub Class_Terminate()
    ws.Close
    Set ws = Nothing
    Set thisForm = Nothing
End Sub

Private Sub thisForm_AfterDelConfirm(Status As Integer)

    If Me.Saved = False Then Me.Saved = (Status = acDeleteOK)
    
End Sub

Private Sub thisForm_AfterUpdate()

    Me.Saved = True
    
End Sub

Private Sub thisForm_Delete(Cancel As Integer)

    If Me.Dirtied = False Then ws.BeginTrans
    Me.Dirtied = True
    
End Sub

Private Sub thisForm_Dirty(Cancel As Integer)

    If Me.Dirtied = False Then ws.BeginTrans
    Me.Dirtied = True
    
End Sub

Private Function OpenRS(ByVal strRecordSource As String) As DAO.Recordset2

Dim db As DAO.Database
Dim rs As DAO.Recordset

    Set db = CurrentDb
    Set rs = db.OpenRecordset(strRecordSource, dbOpenDynaset)
    Set OpenRS = rs
    
End Function

Private Sub thisForm_Unload(Cancel As Integer)

Dim msg As Integer

    If Me.Saved And Me.Dirtied Then
        msg = MsgBox("Do you want to commit all changes?", vbYesNoCancel)
        
        Select Case msg
            Case vbYes
                ws.CommitTrans
            Case vbNo
                ws.Rollback
            Case vbCancel
                Cancel = True
        End Select
    Else
        If Me.Dirtied Then ws.Rollback
    End If
    
End Sub

Private Sub m_save_add_Click()
    Call SaveChanges
    ws.BeginTrans
    DoCmd.GoToRecord , , acNewRec
End Sub

Private Sub m_save_edit_Click()
    Call SaveChanges
    ws.BeginTrans
End Sub

Private Sub m_save_quit_Click()
    Call SaveChanges
    boolFrmDirty = False
    boolFrmSaved = False
    DoCmd.Close acForm, thisForm.Name, acSaveNo
End Sub

Private Sub m_nosave_quit_Click()
    Call DiscardChanges
    boolFrmDirty = False
    boolFrmSaved = False
    DoCmd.Close acForm, thisForm.Name, acSaveNo
End Sub


